/*
 * A list of all distinct float-free 4x4 weave blocks
 * Matrices are written to read from bottom row up like in a squared notebook
 * 2017-02-08: Searched by hand by Abdalla Ahmed
 * 2017-02-09: Encoded in this header file.
 */

const unsigned char WEAVE0[] = {                                                // Diagonals orthogonal
    2, 2, 1, 0,
    2, 2, 0, 1,
    1, 0, 2, 2,
    0, 1, 2, 2
};

const unsigned char WEAVE1[] = {                                                // Diagonals parallel adjacent
    1, 2, 2, 0,
    2, 2, 0, 1,
    2, 0, 1, 2,
    0, 1, 2, 2
};

const unsigned char WEAVE2[] = {                                                // Diagonals parallel offset
    2, 1, 2, 0,
    1, 2, 0, 2,
    2, 0, 2, 1,
    0, 2, 1, 2
};

const unsigned char WEAVE3[] = {                                                // Diagonal and sparse (bishop and knight)
    2, 2, 1, 0,
    1, 2, 0, 2,
    2, 0, 2, 1,
    0, 1, 2, 2
};

const unsigned char WEAVE4[] = {                                                // Diagonal and slashes
    1, 2, 2, 0,
    2, 1, 0, 2,
    2, 0, 2, 1,
    0, 2, 1, 2
};

const unsigned char WEAVE5[] = {                                                // Slashes crossing
    2, 2, 0, 1,
    2, 2, 1, 0,
    1, 0, 2, 2,
    0, 1, 2, 2
};

const unsigned char WEAVE6[] = {                                                // Slashes adjacent
    2, 2, 0, 1,
    1, 2, 2, 0,
    2, 0, 1, 2,
    0, 1, 2, 2
};

const unsigned char WEAVE7[] = {                                                // Slashes offset
    1, 2, 0, 2,
    2, 1, 2, 0,
    2, 0, 2, 1,
    0, 2, 1, 2
};

const unsigned char *WEAVE[] = {WEAVE0, WEAVE1, WEAVE2, WEAVE3, WEAVE4, WEAVE5, WEAVE6, WEAVE7};
